<?php

	// 設定項目
	$consumer_key = '' ;		// クライアントキー

	// パラメータ
	$params = array(
		'consumer_key' => $consumer_key ,
		'image_size' => '600' ,
		'rpp' => '20' ,
		'geo' => '35.681382,139.766084,500km' ,
	) ;

	// GETメソッドで指定がある場合
	foreach( array( 'only' , 'term' , 'geo' , 'rpp' , 'license_type' , 'sort' ) as $val )
	{
		if( isset( $_GET[ $val ] ) && $_GET[ $val ] != '' )
		{
			$params[ $val ] = $_GET[ $val ] ;
		}
	}

	// リクエストURL
	$request_url = 'https://api.500px.com/v1/photos/search' . '?' . http_build_query( $params ) ;		// リクエストURL

	// アイテムデータをJSON形式で取得する (CURLを使用)
	$curl = curl_init() ;

	// オプションのセット
	curl_setopt( $curl , CURLOPT_URL , $request_url ) ;
	curl_setopt( $curl , CURLOPT_HEADER, 1 ) ; 
	curl_setopt( $curl , CURLOPT_SSL_VERIFYPEER , false ) ;								// 証明書の検証を行わない
	curl_setopt( $curl , CURLOPT_RETURNTRANSFER , true ) ;								// curl_execの結果を文字列で返す
	curl_setopt( $curl , CURLOPT_TIMEOUT , 5 ) ;										// タイムアウトの秒数

	// 実行
	$res1 = curl_exec( $curl ) ;
	$res2 = curl_getinfo( $curl ) ;

	// 終了
	curl_close( $curl ) ;

	// 取得したデータ
	$json = substr( $res1, $res2['header_size'] ) ;										// 取得したデータ(JSONなど)
	$header = substr( $res1, 0, $res2['header_size'] ) ;								// レスポンスヘッダー (検証に利用したい場合にどうぞ)

	// HTML用
	$html = '' ;

	// JSONデータをオブジェクト形式に変換する
	$obj = json_decode( $json ) ;

	// 条件指定用フォーム
	$html .= '<h2>条件を指定する</h2>' ;
	$html .= '<p>条件を指定して、写真を検索してみて下さい。</p>' ;
	$html .= '<form>' ;
	$html .= 	'<p style="font-size:.9em; font-weight:700;"><label for="term">検索キーワード (term)</label></p>' ;
	$html .= 		'<p style="margin:0 0 1em;"><input id="term" name="term" placeholder="花火"></p>' ;
	$html .= 	'<p style="font-size:.9em; font-weight:700;"><label for="geo">位置座標 (geo)</label></p>' ;
	$html .= 		'<p style="margin:0 0 1em;"><input id="geo" name="geo" placeholder="35.681382,139.766084,500km"></p>' ;
	$html .= 	'<p style="font-size:.9em; font-weight:700;"><label for="rpp">取得件数 (rpp)</label></p>' ;
	$html .= 		'<p style="margin:0 0 1em;"><input id="rpp" name="rpp" value="20" placeholder="20"></p>' ;
	$html .= 	'<p style="font-size:.9em; font-weight:700;"><label for="only">カテゴリ名 (only)</label></p>' ;
	$html .= 		'<p style="margin:0 0 1em;"><input id="only" name="only" value="" placeholder="Animals"></p>' ;
	$html .= 	'<p style="font-size:.9em; font-weight:700;"><label for="license_type">ライセンス (license_type)</label></p>' ;
	$html .= 		'<p style="margin:0 0 1em;"><input id="license_type" name="license_type" value="" placeholder="1"></p>' ;
	$html .= 	'<p style="font-size:.9em; font-weight:700;"><label for="sort">ソート (sort)</label></p>' ;
	$html .= 		'<p style="margin:0 0 1em;"><input id="sort" name="sort" value="_score" placeholder="_score"></p>' ;
	$html .= 	'<p><button>検索する</button></p>' ;
	$html .= '</form>' ;

	// HTMLを作成
	$html .= '<h2>実行結果</h2>' ;

	// エラー判定
	if( !$obj || !isset($obj->photos) )
	{
		$html .= '<p>データを取得できませんでした…。設定を再確認して下さい。</p>' ;
	}
	else
	{
		foreach( $obj->photos as $item )
		{
			// 成人コンテンツをスキップ
			if( isset( $item->nsfw ) && $item->nsfw )
			{
				continue ;
			}

			// 各データ
			$id = $item->id ;		// メディアID
			$name = ( isset($item->name) ) ? $item->name : '' ;		// 写真のタイトル
			$description = ( isset($item->description) ) ? $item->description : '' ;		// 写真の説明
			$image_url = $item->image_url ;		// 写真のURL
			$created_at = $item->created_at ;		// 投稿日時

			// ユーザー情報
			$user_id = $item->user_id ;		// 投稿者ID
			$user_username = $item->user->username ;		// ユーザーネーム
			$user_avatars = ( isset($item->user->avatars->default->https) ) ? $item->user->avatars->default->https : '' ;		// アバター画像

			// 場所情報
			$country = ( isset($item->location_details->country[0]) ) ? $item->location_details->country[0] : '' ;		// 国名
			$latitude = ( isset($item->latitude) ) ? $item->latitude : '' ;		// 緯度
			$longitude = ( isset($item->longitude) ) ? $item->longitude : '' ;		// 緯度

			// 日付の整形
			$created_at = date( 'Y/m/d H:i' , strtotime( $created_at ) ) ;

			// ブラウザに出力
			$html .= '<dl>' ;
			$html .= 	'<dt>投稿者のID</dt>' ;
			$html .= 		'<dd>' . $user_id . '</dd>' ;
			$html .= 	'<dt>投稿者のユーザーネーム</dt>' ;
			$html .= 		'<dd><a href="https://500px.com/' . $user_username . '" target="_blank">' . $user_username . '</a></dd>' ;

			// アイコン画像がある場合
			if( $user_avatars )
			{
				$html .= 	'<dt>投稿者のアイコン</dt>' ;
				$html .= 		'<dd><img class="_img" src="' . $user_avatars . '" width="auto" height="75"></dd>' ;
			}

			$html .= 	'<dt>写真</dt>' ;
			$html .= 		'<dd><img class="_img" src="' . $image_url . '"></dd>' ;

			// 写真のタイトル
			if( $name )
			{
				$html .= 	'<dt>写真のタイトル</dt>' ;
				$html .= 		'<dd>' . $name . '</dd>' ;
			}

			// 写真の説明
			if( $description )
			{
				$html .= 	'<dt>写真の説明</dt>' ;
				$html .= 		'<dd>' . $description . '</dd>' ;
			}

			// 場所名がある場合
			if( $country )
			{
				$html .= 	'<dt>国名</dt>' ;
				$html .= 		'<dd>' . $country . '</dd>' ;
			}

			// 緯度、経度がある場合
			if( $latitude && $longitude )
			{
				$html .= 	'<dt>地図</dt>' ;
				$html .= 		'<dd><a href="https://www.google.co.jp/maps/@' . $latitude . ',' . $longitude . ',15z" target="_blank">Google Mapsで位置を確認する</a></dd>' ;
			}

			$html .= 	'<dt>投稿日時</dt>' ;
			$html .= 		'<dd>' . $created_at . '</dd>' ;

			$html .= '</dl>' ;
		}
	}

	// 取得したデータ
	$html .= '<h2>取得したデータ</h2>' ;
	$html .= '<p>下記のデータを取得できました。</p>' ;
	$html .= 	'<h3>JSON</h3>' ;
	$html .= 	'<p><textarea rows="8">' . $json . '</textarea></p>' ;
	$html .= 	'<h3>レスポンスヘッダー</h3>' ;
	$html .= 	'<p><textarea rows="8">' . $header . '</textarea></p>' ;

?><!DOCTYPE html>
<html>
	<head>
		<meta charset="UTF-8">
		<meta name="robots" content="noindex,nofollow">

		<!-- ビューポートの設定 -->
		<meta name="viewport" content="width=device-width, initial-scale=1.0">

		<title>500px APIで写真検索をするサンプルデモ</title><!-- 

/********************************************************************************

	SYNCER 〜 知識、感動をみんなと同期(Sync)するブログ

	* 配布場所
	https://syncer.jp/500px-api-matome

	* 動作確認
	https://syncer.jp/500px-api-matome/demo/photos-search.php

	* 最終更新日時
	2015/08/03 13:18

	* 作者
	あらゆ

	** 連絡先
	Twitter: https://twitter.com/arayutw
	Facebook: https://www.facebook.com/arayutw
	Google+: https://plus.google.com/114918692417332410369/
	E-mail: info@syncer.jp

	※ バグ、不具合の報告、提案、ご要望など、お待ちしております。
	※ 申し訳ありませんが、ご利用者様、個々の環境における問題はサポートしていません。

********************************************************************************/

		-->
	</head>
<body>



<?php echo $html ?>


<p style="text-align:center"><a href="https://syncer.jp/500px-api-matome">配布元: Syncer</a></p>






</body>
</html>
